function [modelNew,parsedGPR] = convertToWithoutOR(model)
%convertToWithoutOR represents reactions with OR associations in separate form.
%INPUT
% model                 COBRA model structure
%
%OUTPUTS
% modelNew              model in without OR form
%
% Ehsan Motamedian 11/02/15
warning off all
parsedGPR = [];
corrRxn = [];
cnt = 1;

for i = 1:length(model.rxns)
    if length(model.grRules{i}) > 1
        [parsing{1,1},parsing{2,1}] = strtok(model.grRules{i},'or');
        for j = 2:1000
            [parsing{j,1},parsing{j+1,1}] = strtok(parsing{j,1},'or');
            if isempty(parsing{j+1,1})==1
                break
            end
        end
        
        for j = 1:length(parsing)
            for k = 1:1000
                [parsing{j,k},parsing{j,k+1}] = strtok(parsing{j,k},'and');
                if isempty(parsing{j,k+1})==1
                    break
                end
            end
        end
        for j = 1:size(parsing,1)
            for k = 1:size(parsing,2)
                parsing{j,k} = strrep(parsing{j,k},'(','');
                parsing{j,k} = strrep(parsing{j,k},')','');
                parsing{j,k} = strrep(parsing{j,k},' ','');
            end
        end
        
        for j = 1:size(parsing,1)-1
            newparsing(j,:) = parsing(j,1:length(parsing(j,:))-1);
        end
        
        parsing = newparsing;
        
        
        for j = 1:size(parsing,1)
            for k = 1:size(parsing,2)
                if length(parsing{j,k}) == 0
                    parsing{j,k} = '';
                end
            end
        end
        
        
        num = size(parsing,1);
        for j = 1:num
            sizeP = length(parsing(j,:));
            if sizeP > size(parsedGPR,2)
                for k = 1:size(parsedGPR,1)
                    parsedGPR{k,sizeP} = {''};
                end
            end
            
            for l = 1:sizeP
                parsedGPR{cnt,l} = parsing(j,l);
            end
            cnt = cnt+1;
        end
        
        for j = 1:num
            corrRxn = [corrRxn;model.rxns(i)];
        end
        
        clear parsing newparsing
        
    end
    
end

for i = 1:size(parsedGPR,1)
    for j = 1:size(parsedGPR,2)
        if isempty(parsedGPR{i,j}) == 1
            parsedGPR{i,j} = {''};
        end
    end
end

i =1 ;
sizeP = size(parsedGPR,1);
while i < sizeP
    if strcmp(parsedGPR{i,1},{''}) == 1
        parsedGPR = [parsedGPR(1:i-1,:);parsedGPR(i+1:end,:)];
        corrRxn = [corrRxn(1:i-1,:);corrRxn(i+1:end,:)];
        sizeP = sizeP-1;
        i=i-1;
    end
    i = i+1;
end

for i = 1:size(parsedGPR,1)
    for j= 1:size(parsedGPR,2)
        parsedGPR2(i,j) = cellstr(parsedGPR{i,j});
    end
end

parsedGPR = parsedGPR2;
[a,b]=size(parsedGPR);
modelNew.rxnGeneMat=zeros(a,length(model.genes));
for i=1:a
    for j=1:b
        [ff,gg]=ismember(parsedGPR(i,j),model.genes);
        if ff==1
            modelNew.rxnGeneMat(i,gg)=1;
        end
    end
end
u=1;
for i=1:length(model.rxns)
    ab=ismember(corrRxn,model.rxns(i));
    if sum(ab)>0
        for j=1:length(ab)
            if ab(j)==1
                modelNew.rxns(j)=model.rxns(i);
                modelNew.S(:,j)=model.S(:,i);
                modelNew.rev(j)=model.rev(i);
                modelNew.lb(j)=model.lb(i);
                modelNew.ub(j)=model.ub(i);
                modelNew.c(j)=model.c(i);
                modelNew.rules(j)=model.rules(i);
                modelNew.grRules(j)=model.grRules(i);
            end
        end
    else
        modelNew.rxns(length(ab)+u)=model.rxns(i);
        modelNew.S(:,length(ab)+u)=model.S(:,i);
        modelNew.rev(length(ab)+u)=model.rev(i);
        modelNew.lb(length(ab)+u)=model.lb(i);
        modelNew.ub(length(ab)+u)=model.ub(i);
        modelNew.c(length(ab)+u)=model.c(i);
        modelNew.rxnGeneMat(length(ab)+u,:)=0;
        modelNew.rules(length(ab)+u)=model.rules(i);
        modelNew.grRules(length(ab)+u)=model.grRules(i);
        u=u+1;
    end
end
modelNew.mets=model.mets;modelNew.b=model.b;modelNew.genes=model.genes;
